#-*- coding:utf-8 -*-
"""
This program is free software.This program is distributed 
WITHOUT ANY WARRANTY.You should use it on your own risk. 

You can modify/redistribute it under the terms of the 
GNU General Public License version 2 or later.
"""

import sys
sys.setdefaultencoding('utf-8')
sys.path.insert(0, 'E:\\Python\\lib')

__script__ = "PyNoteNdb"
__version__ = '0.04(1)'
__author__ = 'masa'
__web__ = 'http://masaland.cocolog-nifty.com/'
__Copyright__ = ' Copyright (c) 2008-2014 masa'

import e32db
import e32
import os
import appuifw
import re
import time
from key_codes import EKeyLeftArrow
from key_codes import EKeyRightArrow

appuifw2_exist = 0
try:
    import appuifw2
    #appuifw = appuifw2
    appuifw2_exist = 1
except ImportError:
    #pass
    appuifw2_exist = 0

try:
    from PyFbuiutil import Fbrowser
    from PyFbuiutil import Getpath
    Err_exit = 0
except:
    rtn = appuifw.query(unicode("Please install PyFbuiutl.py"), "query")
#    sys.exit(0)
    Err_exit = 1


###############  Please change according to your environment.
ini_path = 'E:\\ブリーフケース\\dbdata\\'
ndb_file = 'E:\\ブリーフケース\\dbdata\\DBS_Notepad.ndb' # file of PyNoteNdb
Default_path = 'E:\\ブリーフケース\\dbdata\\'
#org_file = 'E:\\ブリーフケース\\dbdata\\DBS_Notepad.dat' #original file of Notepad
#org_file = 'C:\\PRIVATE\\100012a5\\DBS_101F8878_Notepad.dat'
Fontsize_sw = 0  # global, fontsize switch  0:small 1:large
Eng_sw      = 0  # global,language switch  1=English  0=Japanese
Jump_range = 4 #Jump range (Right/Left Arrow key)
Delimiter = "････････････････････････････････････････"
#
# other global variables
sep_line    = '------------------------------'
LS          = Eng_sw
Sort_ind = 'dkm'
###############


# key word in each language-----------------------
menu_exit      = ['終了','Exit']
menu_wordnext  = ['文字検索','Search word']
menu_fontsize  = ['フォントサイズ (一時的)','Font size (Temporary)']
menu_about     = ['情報','About']
menu_back      = ['戻る','ノート']
menu_note      = ['ノート','Note']
menu_open      = ['開く','Open']
menu_save      = ['完了','Done']
menu_new       = ['ノート新規作成','New note']
menu_delete    = ['ノート削除','Delete note']
menu_editcan   = ['編集のキャンセル','Cancel changes']
menu_file      = ['ファイル','File']
menu_compact   = ['ファイル compact','File compact']
menu_import    = ['インポート ndb','Import ndb']
menu_importtxt = ['インポート   (text)','Import (text)']
menu_exporttxt = ['エクスポート (text)','Export (text)']
menu_list      = ['リスト','List']
menu_back2list = ['リストに戻る','back to list']
menu_alllist   = ['全リストに戻る','back (all list)']
menu_details   = ['ノート詳細','Details']
menu_sort      = ['ソート','Sort']
menu_keysort   = ['ID#  ソート','Sort by ID#']
menu_memosort  = ['メモ ソート','Sort by memo']
menu_timesort  = ['日時 ソート','Sort by Day/Time']
msg_inprocess  = ['処理中です... \n','processing... \n']
msg_inputword  = ['検索文字（１部分可）','Search word\n (Partial allowed)']
msg_noword     = ['文字／ノートが見あたりません','No such word or note']
msg_searchword = ['検索文字: ','Search word: ']
msg_example    = ['電話','Phone']
msg_convert    = ['ndbファイルをインポートします\nデータはマージされます\nよろしいですか',
		  'Import ndb_file\n merge it to current data\n  OK ?']
msg_import     = ['textファイルをインポートします\nデータはマージされます\nよろしいですか',
		  'Import text_file\n replace all data\n  OK ?']
msg_dataerror  = ['data ファイルにエラーがあります\nエラー情報を表示します',
                         'error detected in data file \n please see error list']
msg_ioerror    = ['ファイル入出力でエラーがありました','Input/Output file error']
msg_filename   = ['ファイル名','File name']
msg_overwr     = ['上書きしますか？', 'Allow overwrite ?']
msg_exfile     = ['新規テキスト.txt','new_text.txt']
msg_nofile     = [' ファイルがありません\n','File not exist\n']
msg_makefile   = [' 新規ファイルを作成します\n','make new file\n']
msg_select     = ['選択','select']
msg_org_err    = ['org_file エラーです','org_file error']
#---------------------------------------------------------------------

def confread():
  global Fontsize_sw
  global Eng_sw
  global ndb_file
  global LS
  global Default_path
  global Jump_range

  try:
    ini_file = (ini_path + __script__ + '.ini')
    f = open(ini_file,'r')
    fData = f.read()
    f.close
  except:
    return

  #split by \n and omit line that contain only (CR/LF)
  lnDatalist = [x for x in fData.split("\n") if len(x) > 1]

  for lnData in lnDatalist:
    lnDatawk = re.sub("[ \t]+"," ",lnData)
    lnDatawk = (re.sub("[\n\r]+","",lnDatawk)).strip()
    confData=lnDatawk.split(" ")
    if len(confData) < 2: continue # no confData[1] error
    if   confData[0] == "Fontsize_sw":   Fontsize_sw = int(confData[1])
    elif confData[0]   == "Jump_range":  Jump_range = int(confData[1])
    elif confData[0] == "Eng_sw":        Eng_sw      = int(confData[1])
    elif confData[0] == "ndb_file":         ndb_file = (confData[1])
    elif confData[0] == "Default_path": Default_path = (confData[1])
    if Eng_sw == 1: Eng_sw = LS = 1 #force LS to 0 or 1,
    else:           Eng_sw = LS = 0 # otherwise, it becomes an error


class Notepad:
  def __init__(self):
    self.lock = e32.Ao_lock()
    self.Msglist = []
    self.ss_word = 'None'
    self.sel_list = []
    self.index = 0
    self.MT_flg = '_'
    self.page = 'None'
    self.next_id = 'None'
    self.example = msg_example[LS]
    self.sort_key = 0
    self.first_flg = 1
    self.sel_list_bak = []


  def run(self):
    self.dbms = e32db.Dbms()
    self.ndb = e32db.Db_view()
    self.body = appuifw.Text()
    self.Gpath = Getpath()
    appuifw.app.body = self.body
    appuifw.app.menu = []
    old_title = appuifw.app.title
    if not os.path.exists(ndb_file):
      self.make_newfile()
    try:
        self.dbms.open(unicode(ndb_file))
    except:
        rtn = appuifw.query(unicode('Open Error \n ndb_file'),'query')
        return #Exit

    self.list_setup()
    self.refresh()
    self.lock.wait()
#       all process is executed at this point
    self.disp_result([msg_inprocess[LS]])
    self.dbms.compact()
    appuifw.app.title = old_title
    appuifw.app.body = None
    self.listbox = None
    self.dbms.close()


  def refresh(self, index2zero=None):
    if self.sel_list:
      self.paint('list')
      if self.first_flg == 1:
        self.first_flg = 0
        if appuifw2_exist == 1:
          self.listbox = appuifw2.Listbox(self.sel_list, self.selected)
        else:
          self.listbox = appuifw.Listbox(self.sel_list, self.selected)
        self.listbox.bind(EKeyLeftArrow, lambda: self.jump('b'))
        self.listbox.bind(EKeyRightArrow, lambda: self.jump('f'))
        appuifw.app.body = self.listbox
      else:
        appuifw.app.body = self.listbox
        #*1 back to 0 Listbox pointer (required by appuifw2)
        if index2zero and self.sel_list_bak:
          self.listbox.set_list(self.sel_list_bak, 0) #*1
        if self.index >= len(self.sel_list):   #*0041
          self.index = len(self.sel_list) - 1
        self.listbox.set_list(self.sel_list,self.index)
    else:
      self.paint('word')
      self.Msglist = [(msg_searchword[LS] + self.ss_word + '\n')]
      self.Msglist.append(msg_noword[LS])
      self.disp_result(self.Msglist)


  def cbbword(self):
    self.ss_word = str(appuifw.query(unicode(msg_inputword[LS]),'text', \
					unicode(self.example)))
    if self.ss_word != None:
      self.example = self.ss_word #search again to update list
    else:
      self.ss_word = 'None'
    self.go2newlist()


  def back2list(self):
    if self.page == 'list':
      self.index = self.listbox.current()
    self.paint('list')
    self.refresh()


  def go2newlist(self):
    self.paint('list')
    #*1/*2: don't change this order
    #*1: required by appuifw2.Listbox
    if self.sel_list: #*1
      self.sel_list_bak = [x for x in self.sel_list] #*1
    self.list_setup() #*2
#    self.index = 0  #*0041
    self.refresh(index2zero=True)


  def list_update(self):
    """update list on the screen, don't change search/extract
       condition before call 'list_update'
    """
    self.paint('list')
    self.list_setup()
    #keep self_index
    self.refresh()


  def alllist(self):
    self.ss_word = 'None'
    self.index = 0
    self.go2newlist()


  def fontsize(self):
    global Fontsize_sw
    if Fontsize_sw == 0: Fontsize_sw = 1
    else:                Fontsize_sw = 0
    if self.page == 'note':
      self.disp_result(self.Msglist) # display screen again


  def about(self):
    msg = [('App Name : ' + __script__ + '\n'),
			('Version : ' + __version__ + '\n'),
			('Author : ' + __author__ + '\n' ),
			(__web__  + '\n'),
			(__Copyright__)]
    self.paint('about')
    self.disp_result(msg) # display screen again


  def view_log(self, Log):
    self.paint('about')
    self.disp_result(Log) # display screen again


  def jump(self, flg):
    i = self.listbox.current()
    i_max = len(self.sel_list) - 1
    if flg == 'f': # jump forward
      i = i + Jump_range
      if i > i_max : i = i_max
    else: # b jump backward
      i = i - Jump_range
      if i < 0 : i = 0
    self.listbox.set_list(self.sel_list, i)


  def exit1(self):
    self.lock.signal()


  def set_sortkey(self, flg):
    if flg < 3:
      self.sort_key = flg
    else:
      self.sort_key = 0 # set date/time sort
    self.index = 0
    self.go2newlist()


  def edit_txt(self):
    if self.page == 'list':
      self.index = self.listbox.current()
    fld_id = self.db_id[self.index]
    fld_time, fld_note = self.get_currentdata(fld_id)

    self.paint('edit')
    self.get_newnote(fld_note)


  def get_newnote(self,note):  # dispaly and get edit/new note
    self.body.clear()
    appuifw.app.body = self.body

    if Fontsize_sw == 0: self.body.font = 'dense'   # small
    else:                self.body.font = 'normal'  # large
    self.body.color = 0x006600
    self.body.set(unicode((str(note)),'utf-8'))
    self.body.set_pos(0) #  move cursol to top


  def new_txt(self):
    self.paint('new')
    if self.next_id == 'None':
      # get (max_id# +1) use it for next id#
      query = u"SELECT * FROM Table1"
      self.ndb.prepare(self.dbms,query )
      self.ndb.first_line()
      db_id = []
      if self.ndb.count_line() > 0:
          for k in range(self.ndb.count_line()):
            self.ndb.get_line()
            db_id.append(self.ndb.col(1))
            self.ndb.next_line()
          db_id.sort()
          self.next_id = db_id[-1] + 1
      else:
        self.next_id = 0
#
    msg = ''
    self.get_newnote(msg)


  def save_txt(self):
    if self.page == 'edit': # from edit
      rtn = self.save_editnote()
    else: 					# from new
      rtn = self.save_newnote()

    if rtn == 1:self.go2newlist() # Db changed
    else:       self.back2list()  # Db not changed


  def save_editnote(self):
    fld_id   = self.db_id[self.index]
    fld_time, fld_note = self.get_currentdata(fld_id)
    note = self.body.get()

    if note != fld_note:
      wk = note.strip()
      if len(wk) < 1: # nothing in note_field
        query = u'DELETE FROM Table1 WHERE Key =%d' %(fld_id)
        self.dbms.begin()
        rtn = self.dbms.execute(query)
        self.dbms.commit()
      else: # save
        times = e32db.format_time(time.time()) # get current date/time
        note = note.replace("'","''")
        query = u'UPDATE Table1 SET memo = \'%s\', time = #%s# \
				WHERE Key = %d' % (note, times, fld_id)
        self.dbms.begin()
        rtn = self.dbms.execute(query)
        self.dbms.commit()
      rtn = 1 # Db changed
    else:
      rtn = 0 # Db not changed
    return rtn


  def save_newnote(self):
      note = self.body.get()
      note = note.strip()
      if len(note) > 0:
        times = e32db.format_time(time.time())
        note = note.replace("'","''")
        query = u"INSERT INTO Table1 (Key, time,  memo) VALUES \
				(%d, #%s#, '%s')" %(self.next_id,times,note)
        self.dbms.begin()
        rtn = self.dbms.execute(query)
        self.dbms.commit()
        self.next_id = self.next_id + 1
        rtn = 1 # Db changed
      else:
        rtn = 0 # Db not changed
      return rtn


  def del_txt(self):
    if self.page == 'list':
      self.index = self.listbox.current()
    fld_id   = self.db_id[self.index]
    fld_time, fld_note = self.get_currentdata(fld_id)

    msg = menu_delete[LS] + '\n  (' + fld_note + '..)'
    rtn = appuifw.query(unicode(msg),'query')
    if rtn == 1:
      query = u'DELETE FROM Table1 WHERE Key =%d' %(fld_id)
      self.dbms.begin()
      rtn = self.dbms.execute(query)
      self.dbms.commit()
      if self.index > 0 : self.index = (self.index - 1)
    self.go2newlist()


  def paint(self,flg='about'): # first paint screen
    appuifw.app.title = unicode(__script__ + self.MT_flg + Sort_ind[self.sort_key])
#    body = appuifw.Text()
    appuifw.app.body = self.body
    self.page = flg

    if flg == 'new':
      appuifw.app.menu = [(unicode(menu_save[LS]), self.save_txt),
						(unicode(menu_editcan[LS]), self.back2list)]
      appuifw.app.exit_key_handler = lambda: self.save_txt()

    elif flg == 'edit':
      appuifw.app.menu = [
          (unicode(menu_save[LS]), self.save_txt),
          (unicode(menu_editcan[LS]), self.back2list),
          (unicode(menu_delete[LS]), self.del_txt),
          (unicode(menu_details[LS]), self.details)]
      appuifw.app.exit_key_handler = lambda: self.save_txt()

    elif flg == 'list' or flg == 'note':
      appuifw.app.menu = [
          (unicode(menu_wordnext[LS]), self.cbbword),
          (unicode(menu_note[LS]),
                 ((unicode(menu_new[LS]), self.new_txt),
                  (unicode(menu_open[LS]), self.edit_txt),
                  (unicode(menu_delete[LS]), self.del_txt),
                  (unicode(menu_details[LS]), self.details))),
          (unicode(menu_list[LS]),
                 ((unicode(menu_back2list[LS]),self.back2list),
                  (unicode(menu_alllist[LS]), self.alllist))),
          (unicode(menu_sort[LS]),
                 ((unicode(menu_timesort[LS]),lambda:self.set_sortkey(0)),
                  (unicode(menu_memosort[LS]),lambda:self.set_sortkey(2)),
                  (unicode(menu_keysort[LS]), lambda:self.set_sortkey(1)))),
          (unicode(menu_file[LS]),
                 ((unicode(menu_import[LS]),self.Ndb_import),
                  (unicode(menu_importtxt[LS]),self.data_import),
                  (unicode(menu_exporttxt[LS]),self.data_export),
                  (unicode(menu_compact[LS]), self.exec_compact))),
          (unicode(menu_fontsize[LS]), self.fontsize),
          (unicode(menu_about[LS]), self.about),
          (unicode(menu_exit[LS]), self.exit1)]
#      appuifw.app.exit_key_handler = lambda: self.back2list()
      appuifw.app.exit_key_handler = lambda: self.exit1()

    elif flg == 'word':
      appuifw.app.menu = [
          (unicode(menu_wordnext[LS]), self.cbbword),
          (unicode(menu_new[LS]), self.new_txt),
          (unicode(menu_list[LS]),
                 ((unicode(menu_back2list[LS]),self.back2list),
                  (unicode(menu_alllist[LS]), self.alllist))),
          (unicode(menu_sort[LS]),
                 ((unicode(menu_timesort[LS]),lambda:self.set_sortkey(0)),
                  (unicode(menu_memosort[LS]),lambda:self.set_sortkey(2)),
                  (unicode(menu_keysort[LS]), lambda:self.set_sortkey(1)))),
          (unicode(menu_file[LS]),
                 ((unicode(menu_import[LS]),self.Ndb_import),
                  (unicode(menu_importtxt[LS]),self.data_import))),
          (unicode(menu_exit[LS]), self.exit1)]
      appuifw.app.exit_key_handler = lambda: self.back2list()

    else: ## 'about' and others
      appuifw.app.menu = [(unicode(menu_back2list[LS]), self.back2list)]
      appuifw.app.exit_key_handler = lambda: self.back2list()


  def disp_result(self,msglist):  # dispaly search result
    self.body.clear()
    appuifw.app.body = self.body
    if Fontsize_sw == 0: self.body.font = 'dense'   # small
    else:                self.body.font = 'normal'  # large
    self.body.color = 0x000000
    for i in range(len(msglist)):
      self.body.add(unicode((str(msglist[i])),'utf-8'))
    self.body.set_pos(0) #  move cursol to top
    e32.ao_sleep(0.001,) # change screen


  def list_setup(self):
    self.db_id   = []
    self.sel_list = []

    appuifw.app.menu = []
    self.disp_result([msg_inprocess[LS]])

    if 	self.ss_word == 'None':
      self.MT_flg = "_"
    else:
      self.MT_flg = "#"

    if self.sort_key ==   1: # sort by ID#(Key)
      query = u'SELECT * FROM Table1 ORDER BY Key ASC'
    elif self.sort_key == 2: # sort by memo
      query = u'SELECT * FROM Table1 ORDER BY memo ASC'
    else:               #0 or another, sort by day/time
      query = u'SELECT * FROM Table1 ORDER BY time DESC'
    self.ndb.prepare(self.dbms,query )
    self.ndb.first_line()

    for k in range(self.ndb.count_line()):
      self.ndb.get_line()
      sflg0 = 1

      if self.ss_word != 'None':
        if re.search(unicode(self.ss_word),self.ndb.col(3), re.I) == None : sflg0 = 0

      if sflg0 == 1:
        self.db_id.append(self.ndb.col(1))
        times = e32db.format_time(self.ndb.col(2))
        times = times.replace('.000000','') # 18:20:00.000000 -> 18:20:00
#         times = time in db, timewk = current time 
        timewk = (e32db.format_time(time.time())).replace('.000000','')

        if times[0:10] == timewk[0:10]:# Date is today
          timewk = '__' + (times[11:16]) + ' '
        else:
          timewk = times[3:10] + ' '
        self.sel_list.append(timewk + ' ' + self.ndb.col(3)[:14])
      self.ndb.next_line()

    if len(self.db_id) == 0: ##  Search result not exist
      self.sel_list = [] #when sel_list is empty,disp 'empty' in refresh


  def selected(self):
    self.edit_txt()

  def details(self):
#  def selected(self):
    if self.page == 'list':
      self.index = self.listbox.current()
    fld_id   = self.db_id[self.index]
    fld_time, fld_note = self.get_currentdata(fld_id)


    self.Msglist = [('ID#: ' + str(fld_id) + '\n' + str(fld_time) \
			+ '\n' + sep_line + '\n' + fld_note)]
#    self.paint('note')
    self.paint('about')
    self.disp_result(self.Msglist)


  def exec_compact(self):
    self.disp_result([msg_inprocess[LS]])
    self.dbms.compact()
    self.dbms.close()
    self.dbms.open(unicode(ndb_file))
    self.back2list()


  def get_currentdata(self,fld_id):
    id = fld_id
    query = u"SELECT * FROM Table1 WHERE Key=%d" %(id)
    self.ndb.prepare(self.dbms,query )
    self.ndb.first_line()
    self.ndb.get_line()
    times = e32db.format_time(self.ndb.col(2))
    times = times.replace('.000000','') # 18:20:00.000000 -> 18:20:00
    return times, self.ndb.col(3)
#     return time, note


##
  def make_newfile(self):
    """
    file not exist ,make new file
    """
    appuifw.note(unicode(msg_nofile[LS]+msg_makefile[LS]),'info')
    self.dbms.create(unicode(ndb_file))
    self.dbms.open(unicode(ndb_file))

    query = u'CREATE TABLE Table1 (Key INTEGER, time TIMESTAMP, \
			memo LONG VARCHAR)'
    rtn = self.dbms.execute(query)
    self.dbms.close()


##
  def Ndb_import(self):
    """
    import(merge) data from ndb file
    """

    # get file path to read
    org_file = self.Gpath.get_read_path(title = msg_select[LS], \
                                      default_path = Default_path)

    if org_file == None or not os.path.isfile(org_file):
      self.back2list()
    else:
      rtn = appuifw.query(unicode(msg_convert[LS]),'query')
      if not rtn:
          self.back2list()
      else:

        self.paint('about')

        # import proc
        db_list = []
        db_time = []
        db_id = []

        self.disp_result([msg_inprocess[LS]])

        self.dbms.close() # close ndb_file

        try:
            self.dbms.open(unicode(org_file)) 
        except:
            rtn = appuifw.query(unicode(msg_org_err[LS] + '\n' + \
                              os.path.basename(org_file)),'query')
            self.dbms.open(unicode(ndb_file))
            self.back2list()
            return

        query = u"SELECT * FROM Table1"
        self.ndb.prepare(self.dbms,query )
        self.ndb.first_line()

        for k in range(self.ndb.count_line()):
          self.ndb.get_line()

          if len(self.ndb.col(3)) != 0:
            db_id.append(self.ndb.col(1))
            db_list.append(self.ndb.col(3))
            times = self.ndb.col(2)
            db_time.append(times)

          self.ndb.next_line()
        self.dbms.close() # close org_file

        self.dbms.open(unicode(ndb_file))
        # get (max_id# +1) use it for next id#
        if self.next_id == 'None':
          query = u"SELECT * FROM Table1"
          self.ndb.prepare(self.dbms,query )
          self.ndb.first_line()
          wk_db_id = []
          if self.ndb.count_line() > 0:
              for k in range(self.ndb.count_line()):
                self.ndb.get_line()
                wk_db_id.append(self.ndb.col(1))
                self.ndb.next_line()
              wk_db_id.sort()
              self.next_id = wk_db_id[-1] + 1
          else:
            self.next_id = 0

        # out put proc
        cnt = 0 # for dispaly
        db_id_len = len(db_id)
        for k in range(db_id_len):
          fld_id = db_id[k]
          fld_time = e32db.format_time(db_time[k])
          fld_note = (db_list[k]).replace("'", "''")

          query = u'INSERT INTO Table1 (Key, time, memo) VALUES \
			(%d, #%s#, \'%s\' )' %(self.next_id, fld_time, fld_note)  
          self.dbms.begin()
          rtn = self.dbms.execute(query)
          self.dbms.commit()
          self.next_id = self.next_id +1

          if (cnt % 5) == 0:
              self.disp_result([ msg_inprocess[LS] + '*** %d / %d ***' % \
                                                    (cnt, db_id_len)])
          cnt = cnt + 1
        self.alllist()
#  end of convert


  def data_import(self):
      """
      import Item data from data file (not merge, all data replaced)
      """
      # get file path to read
      data_file = self.Gpath.get_read_path(title=msg_select[LS], \
                         default_path = Default_path)

      if data_file == None or not os.path.isfile(data_file):
          self.back2list()
          return
      else:
          rtn = appuifw.query(unicode(msg_import[LS]),'query')
          if not rtn:
              self.back2list()
              return

      # import
      db_id   = []
      db_time = []
      db_item = []
      Log = ''
      wk_db_item = ''
      dt_cnt = 1 #data counter
      cnt = 0 # counter (util)

      self.paint('about')
      self.disp_result([msg_inprocess[LS]])

      try:
          f = open(data_file, 'r')
      except:
          rtn = appuifw.query(unicode(msg_ioerror[LS]),'query')
          return
      f_data = unicode(f.read()).strip()
      lines = (f_data.split(u"\n"))

      wk_delimiter = unicode(Delimiter)[:30]
      for line in lines:
          cnt = cnt + 1 # line count in each topic

          if re.search(wk_delimiter, line, 0) == None: # not delimiter
              if cnt == 1: # id
                  wk_db_id = line
              elif cnt == 2: # time
                  try:
                      time_data = float(line)
                      if time_data > 1000: # exist time data
                          wk_db_time = e32db.format_time(time_data)
                      else:
                          wk_db_time = e32db.format_time(time.time())
                  except:
                      Log = Log + 'data ' + str(dt_cnt) + ' Time data type error\n'
                      wk_db_time = 0
              else: # >2 item data
                  if wk_db_item: wk_db_item = wk_db_item + u"\u2029" + line
                  else:          wk_db_item = line[:]

          else: # delimiter
              if cnt < 4: # incomplete data
                  Log = Log + 'data ' + str(dt_cnt) + ' Too short data error\n'
              else: #
                  db_id.append(wk_db_id)
                  db_time.append(wk_db_time)
                  db_item.append(wk_db_item)
              wk_db_item = ''
              cnt = 0
              dt_cnt = dt_cnt + 1
      else: # final line is not delimiter
          if cnt < 1: # no data
              pass
          elif cnt < 3: # incomplete data
              Log = Log + 'data ' + str(dt_cnt) + ' Too short data error\n'
          else: #
              db_id.append(wk_db_id)
              db_time.append(wk_db_time)
              db_item.append(wk_db_item)
      #end for

      # some error detecred in data_file
      if Log:
          # disp error message
          msg = Log.split("\n")[0:20]
          msg = [x+"\n" for x in msg if len(x)>1]
          msg.append("...")
          self.view_log(msg)
          rtn = appuifw.query(unicode(msg_dataerror[LS]),'query') 
          return

      # no error
#      # delete all data in pdb file
#      query = u'DELETE FROM Table1 WHERE Key <%d' %(int(1000))
#      self.dbms.begin()
#      rtn = self.dbms.execute(query)
#      self.dbms.commit()
#      self.index = 0

      # get (max_id# +1) use it for next id#
      if self.next_id == 'None':
          query = u"SELECT * FROM Table1"
          self.ndb.prepare(self.dbms,query )
          self.ndb.first_line()
          wk_db_id = []
          if self.ndb.count_line() > 0:
              for k in range(self.ndb.count_line()):
                  self.ndb.get_line()
                  wk_db_id.append(self.ndb.col(1))
                  self.ndb.next_line()
              wk_db_id.sort()
              self.next_id = wk_db_id[-1] + 1
          else:
              self.next_id = 0

      # output to empty (pdb) file
      cnt = 0 # for dispaly
      db_item_len = len(db_item)
      for k in range(db_item_len):
          fld_time = db_time[k]
          fld_item = (db_item[k]).replace("'", "''")
          query = u'INSERT INTO Table1 (Key, time, memo) VALUES \
               (%d, #%s#, \'%s\' )' %(self.next_id, fld_time, fld_item) 
#          self.dbms.begin()
          rtn = self.dbms.execute(query)
#          self.dbms.commit()
          self.next_id = self.next_id +1

          if (cnt % 5) == 0:
              self.disp_result([ msg_inprocess[LS] + '*** %d / %d ***' % \
                                                       (cnt, db_item_len)])
          cnt = cnt + 1
      self.alllist()

 # end of convert


  def data_export(self):
    """
    export "selected data" (they are displayed on the screen) to data file
    """
    #get file path to write
    out_file = self.Gpath.get_write_path(title=msg_filename[LS], \
                     default_path=Default_path, \
                     msg_ow=msg_overwr[LS], msg_fn=msg_filename[LS], \
                     msg_ex=msg_exfile[LS])

    if out_file != None:
      #display "export in process"
      self.paint('about')
      self.disp_result([msg_inprocess[LS]], )

      #convert selected data to data format
      out_dt = ''
      wk_delimiter = Delimiter.decode('UTF-8')
      wk_db_id = self.db_id[:]
      wk_db_id.sort()
      for id in wk_db_id:
        query = u"SELECT * FROM Table1 WHERE Key=%d" %(id)
        self.ndb.prepare(self.dbms,query )
        self.ndb.first_line()
        self.ndb.get_line()
        Id, Time, Item = self.ndb.col(1), self.ndb.col(2), self.ndb.col(3)
        Item = Item.replace(u"\u2029", u"\n")
        out_dt = out_dt + "%s\n%s\n%s\n%s\n" % \
                 (str(Id) , str(Time) , Item, wk_delimiter)

      try:
        f = open(out_file,'w')
        try:
          f.write(out_dt.encode('UTF-8'))
        finally:
          f.close()
      except:
        rtn = appuifw.query(unicode(msg_ioerror[LS]),'query')

    self.back2list()
# end of convert


if __name__ == '__main__':
  if Err_exit == 0:
    confread()
    Np = Notepad()
    Np.run()
#  appuifw.app.set_exit()
#  sys.exit()
